> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cockroachlabs.com/llms.txt
> Use this file to discover all available pages before exploring further.

# CREATE EXTERNAL CONNECTION

You can use external connections to specify and interact with resources that are external from CockroachDB. With `CREATE EXTERNAL CONNECTION`, you define a name for an external connection while passing the provider URI and query parameters. [`BACKUP`](/docs/stable/backup), [`RESTORE`](/docs/stable/restore), [`IMPORT INTO`](/docs/stable/import-into), [`EXPORT`](/docs/stable/export), and [`CREATE CHANGEFEED`](/docs/stable/create-changefeed#confluent-schema-registry) queries can interact with the defined external connection instead of a required, provider-specific URI. As a result, you can decouple the management of the external resource from the operation in which you're using them.

`CREATE EXTERNAL CONNECTION` will validate the URI by writing, reading, and listing a test file to the external storage URI. If you're using a [KMS URI](/docs/stable/take-and-restore-encrypted-backups.md), `CREATE EXTERNAL CONNECTION` will encrypt and decrypt a file. You'll find a `crdb_external_storage_location` file in your external storage as a result of this test. Each of the operations that access the external connection is aware of the raw URI that is parsed to configure, authenticate, and interact with the connection.

You may need to periodically rotate your authentication token for an external connection before the old token expires. For information on how to update the connection URI to use a new token, consult [`ALTER EXTERNAL CONNECTION`](/docs/stable/alter-external-connection).

The [privilege model](#required-privileges) for external connections means that you can delegate the creation and usage of external connections to the necessary users or roles.

You can also use the following SQL statements to work with external connections:

* [`SHOW EXTERNAL CONNECTION`](/docs/stable/show-external-connection)
* [`SHOW CREATE EXTERNAL CONNECTION`](/docs/stable/show-create-external-connection)
* [`DROP EXTERNAL CONNECTION`](/docs/stable/drop-external-connection)
* [`ALTER EXTERNAL CONNECTION`](/docs/stable/alter-external-connection)

## Required privileges

To create an external connection, a user must have the `EXTERNALCONNECTION` [system-level privilege](/docs/stable/security-reference/authorization.md#supported-privileges). `root` and [`admin`](/docs/stable/security-reference/authorization#admin-role) users have this system-level privilege by default and are capable of granting the `EXTERNALCONNECTION` system-level privilege to other users and roles with or without the [`GRANT OPTION`](/docs/stable/grant).

For example:

```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
GRANT SYSTEM EXTERNALCONNECTION TO user;
```

To use a specific external connection during an operation, the user must also have the `USAGE` privilege on that connection:

For example:

```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
GRANT USAGE ON EXTERNAL CONNECTION backup_bucket TO user;
```

## Synopsis

![create\_external\_connection syntax diagram](https://mintcdn.com/cockroachlabs/7gzGESYW_aT0XysP/images/sql-diagrams/v26.3/create_external_connection.svg?fit=max\&auto=format\&n=7gzGESYW_aT0XysP\&q=85\&s=346ce96433f392e88ba82ec88c35823d)

### Parameters

| Parameter | Description |
| - | - |
| `connection_name` | The name that represents the external connection. |
| `connection_URI` | The storage/sink URI that the external connection will reference. |

## Supported external storage and sinks

| Storage or sink | Operation support |
| - | - |
| [Amazon MSK](/docs/stable/changefeed-sinks.md#amazon-msk) | Changefeeds |
| [Amazon S3](/docs/stable/use-cloud-storage.md) | Backups, restores, imports, exports, changefeeds |
| [Amazon S3 KMS](/docs/stable/take-and-restore-encrypted-backups.md#aws-kms-uri-format) | Encrypted backups |
| [Azure Storage](/docs/stable/use-cloud-storage.md) | Backups, restores, imports, exports, changefeeds |
| [Confluent Cloud](/docs/stable/changefeed-sinks.md#confluent-cloud) | Changefeeds |
| [Confluent Schema Registry](/docs/stable/create-changefeed.md#confluent-schema-registry) | Changefeeds |
| [Google Cloud Pub/Sub](/docs/stable/changefeed-sinks.md) | Changefeeds |
| [Google Cloud Storage](/docs/stable/use-cloud-storage.md) | Backups, restores, imports, exports, changefeeds |
| [Google Cloud Storage KMS](/docs/stable/take-and-restore-encrypted-backups.md#google-cloud-kms-uri-format) | Encrypted backups |
| [HTTP(S)](/docs/stable/changefeed-sinks.md) | Changefeeds |
| [Kafka](/docs/stable/changefeed-sinks.md#kafka) | Changefeeds |
| [Nodelocal](/docs/stable/use-cloud-storage.md) | Backups, restores, imports, exports, changefeeds |
| [PostgreSQL](/docs/stable/set-up-physical-cluster-replication.md#connection-reference) connections | Physical cluster replication |
| [Userfile](/docs/stable/use-userfile-storage.md) | Backups, restores, imports, exports, changefeeds |
| [Webhook](/docs/stable/changefeed-sinks.md#webhook-sink) | Changefeeds |

For more information on authentication and forming the URI that an external connection will represent, refer to the storage or sink pages linked in the table.

### Changefeed sinks as external connections

Consider the following when you create an external connection for changefeeds:

* You can only include the query parameters and options that Kafka sinks support. Refer to the [Options](/docs/stable/create-changefeed.md#options) table and the Kafka [query parameters](/docs/stable/changefeed-sinks.md#kafka) for more detail.
* To restrict a user's access to changefeed data and sink credentials, enable the `changefeed.permissions.require_external_connection_sink.enabled` cluster setting. When you enable this setting, users with the [`CHANGEFEED` privilege](/docs/stable/create-changefeed#required-privileges) on a set of tables can only create changefeeds into [external connections](/docs/stable/create-external-connection.md).

## External connection URI format

To form the external connection URI in operation statements, use the `external://` scheme followed by the name of the external connection.

For an external connection named `backup_storage`:

```
'external://backup_storage'
```

See the [examples](#create-an-external-connection-for-cloud-storage) in the next section for details on external connection creation.

## Examples

The examples in this section demonstrate some of the storage and operation options that external connections support.

### Create an external connection for cloud storage

In this example, you create an external connection for an Amazon S3 bucket that will store your backups. Then, you use the external connection to restore the backup to your cluster.

1. Define your external connection that references the S3 bucket's URI:

   ```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
   CREATE EXTERNAL CONNECTION backup_bucket AS 's3://bucket name?AWS_ACCESS_KEY_ID={access key}&AWS_SECRET_ACCESS_KEY={secret access key}';
   ```

2. Verify that the new external connection was created successfully with [`SHOW CREATE EXTERNAL CONNECTION`](/docs/stable/show-create-external-connection):

   ```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
   SHOW CREATE ALL EXTERNAL CONNECTIONS;
   ```

   ```
   connection_name |                                                                              create_statement
   ----------------+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   backup_bucket   | CREATE EXTERNAL CONNECTION 'backup_bucket' AS 's3://bucket name?AWS_ACCESS_KEY_ID={access key}&AWS_SECRET_ACCESS_KEY={secret access key}'
   ```

3. Run the backup to your S3 bucket using the external connection's name:

   ```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
   BACKUP DATABASE movr INTO 'external://backup_bucket' AS OF SYSTEM TIME '-10s' WITH revision_history;
   ```

   If you are creating an external connection with [`BACKUP` query parameters](/docs/stable/backup#query-parameters) or [authentication](/docs/stable/cloud-storage-authentication.md) parameters, you must pass them in uppercase otherwise you will receive an `unknown query parameters` error.

4. Use [`SHOW BACKUP`](/docs/stable/show-backup) to view your backups in the storage defined by the external connection:

   ```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
   SHOW BACKUPS IN 'external://backup_bucket';
   ```

   ```
           path
   ------------------------
   2022/09/19-134559.68
   2022/10/10-192044.40
   (2 rows)
   ```

5. In the event that a restore is necessary, use `RESTORE` with the external connection:

   ```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
   RESTORE DATABASE movr FROM LATEST IN 'external://backup_bucket';
   ```

6. When you no longer need the external connection, you can delete it with [`DROP EXTERNAL CONNECTION`](/docs/stable/drop-external-connection):

   ```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
   DROP EXTERNAL CONNECTION backup_bucket;
   ```

### Create an external connection for a changefeed sink

In this example, you create an external connection to a Kafka sink to which a changefeed will emit messages. When you create the external connection, you will include the necessary query parameters for your changefeed. As a result, you will only need to specify the external connection's name when creating a changefeed rather than the Kafka URI and parameters.

1. Define your external connection that references the Kafka sink URI and any [connection parameters](/docs/stable/changefeed-sinks.md#kafka):

   ```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
   CREATE EXTERNAL CONNECTION kafka_sink AS 'kafka://broker.address.com:9092?topic_prefix=bar_&tls_enabled=true&ca_cert={certificate}&sasl_enabled=true&sasl_user={sasl user}&sasl_password={url-encoded password}&sasl_mechanism=SCRAM-SHA-256';
   ```

> [!NOTE]
>
> If you are creating an external connection with [`CREATE CHANGEFEED` query parameters](/docs/stable/create-changefeed#query-parameters), you must pass them in lowercase otherwise you will receive an `unknown query parameters` error.

1. Create your changefeed using the external connection's name:

   ```sql theme={"theme":{"light":"catppuccin-mocha","dark":"catppuccin-mocha"}}
   CREATE CHANGEFEED FOR TABLE movr.users INTO 'external://kafka_sink' WITH resolved;
   ```

## See also

* [`CREATE CHANGEFEED`](/docs/stable/create-changefeed#confluent-schema-registry)
* [`BACKUP`](/docs/stable/backup)
* [`RESTORE`](/docs/stable/restore)
* [`EXPORT`](/docs/stable/export)
* [`IMPORT INTO`](/docs/stable/import-into)
* [`DROP EXTERNAL CONNECTION`](/docs/stable/drop-external-connection)
* [`SHOW CREATE EXTERNAL CONNECTION`](/docs/stable/show-create-external-connection)
* [`ALTER EXTERNAL CONNECTION`](/docs/stable/alter-external-connection)
